% MTODO 3 
% TEST 3-1. CLCULO DEL ESTADSTICO DE CONTRASTE.
%
% La referencia utilizada ha sido:
%
%	J. S. Cnovas, A. Guillamn
%	PERMUTATIONS AND TIME SERIES ANALYSIS
%	Chaos 19 (2009), 043103

function Estadistico_contraste=calcula_EC_CyG1(serie_temp,m)

serie=serie_temp; % serie temporal
T=length(serie); % nmero de elementos de la serie
% k=fix(T/m); % nmero de tramos

M_permutaciones=zeros(factorial(m),m);

trozo_serie1=serie(1:m);
[trozo_ordenado1,permutacion1]=sort(trozo_serie1);
M_permutaciones(1,:)=permutacion1;
Npermutaciones_diferentes=1;

for cont1=m+1:m:T-m+1
    
    trozo_serie=serie(cont1:cont1+m-1);
    [trozo_ordenado,permutacion]=sort(trozo_serie);
        
    testigo=1;
    
    for cont2=1:Npermutaciones_diferentes
        
        if isequal(M_permutaciones(cont2,:),permutacion)
            
            testigo=0;
            break            
            
        end
        
    end
    
    if testigo
        
    Npermutaciones_diferentes=Npermutaciones_diferentes+1;    
    M_permutaciones(Npermutaciones_diferentes,:)=permutacion;
    
    end
    
end

Estadistico_contraste=Npermutaciones_diferentes; % estadstico de contraste

% valores_criticos=load(strcat('VECTORm',num2str(m),'nc',num2str(nivel_confianza),'.txt'));
% T_valores_criticos=length(valores_criticos);
%
% if k>T_valores_criticos
%    
%    valor_critico=valores_criticos(T_valores_limite);
%    
% else
%
%    valor_critico=valores_criticos(k);
%    
% end
%
% if Estadistico_contraste>=valor_critico
%    
%    t3_1=1;
%    
% else
%        
%    t3_1=0;
%        
% end
